﻿using System.IO;
using System.Runtime.Serialization.Json;

public class JsonSerializer<T>
{
    public JsonSerializer() { }

    public string Serialize(T instance)
    {
        using (MemoryStream stream = new MemoryStream())
        {
            DataContractJsonSerializer ser = new DataContractJsonSerializer(typeof(T));
            ser.WriteObject(stream, instance);
            stream.Position = 0;

            using (StreamReader rdr = new StreamReader(stream))
            {
                return rdr.ReadToEnd();
            }
        }
    }

    public T Deserialize(string json)
    {
        using (MemoryStream stream = new MemoryStream(System.Text.ASCIIEncoding.ASCII.GetBytes(json)))
        {
            DataContractJsonSerializer serializer = new DataContractJsonSerializer(typeof(T));
            T result = (T)serializer.ReadObject(stream);
            return result;    
        }
    }
}