﻿<%@ Page Language="C#" EnableViewState="false" AutoEventWireup="true"  CodeFile="BuildSM.aspx.cs" Inherits="BuildSM" %>

<%@ Register Assembly="Infragistics35.Web.v9.2, Version=9.2.20092.224, Culture=neutral, PublicKeyToken=7dd5c3163f2cd0cb"
    Namespace="Infragistics.Web.UI.GridControls" TagPrefix="ig" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
    <link rel="Stylesheet" type="text/css" href="global.css" />
    <link rel="Stylesheet" type="text/css" href="build.css" />
    <script type="text/javascript" src="scripts/jQuery/jquery-1.3.2.js"></script>   
</head>
<body>
    <form id="form1" runat="server">
        <asp:ScriptManager runat="server">
            <Scripts>
                <asp:ScriptReference 
                    Path="~/Scripts/MicrosoftAjax/MicrosoftAjax.js" 
                    Name="MicrosoftAjax.js" />
                <asp:ScriptReference 
                    Path="~/Scripts/MicrosoftAjax/MicrosoftAjaxTemplates.js" 
                    ScriptMode="Inherit" />
                <asp:ScriptReference 
                    Assembly="Infragistics35.Web.v9.2, Version=9.2.20092.224, Culture=neutral, PublicKeyToken=7DD5C3163F2CD0CB" 
                    Name="Infragistics.Web.UI.SharedScripts.igDragDrop.js" />
		        <asp:ScriptReference 
		            Assembly="Infragistics35.Web.v9.2, Version=9.2.20092.224, Culture=neutral, PublicKeyToken=7DD5C3163F2CD0CB" 
		            Name="Infragistics.Web.UI.Scripts.5_igObjects.js" />
            </Scripts>
        </asp:ScriptManager>
    </form>
    <h1 id="logo">Ugly Outfitters</h1>
    <div id="mainContainer">
        <div id="shirtListView" class="thumbs sys-template">
            <div class="shirt"><img sys:src="{{ 'images/thumb/' + FileNameFull }}" sys:class="{{ $index + ' s' }}" sys:alt="{{Title}}" sys:title="{{Title}}" width="65" height="66" /></div>
        </div>
        
        <div id="fullView" class="sys-template">
            <div id="img">
                <div id="shirtimg"><img id="shirt" sys:src="{{ 'images/full/' + ShirtFileName }}" width="249" height="255" /></div>
                <div id="pantsimg"><img id="pant" sys:src="{{ 'images/full/' + PantsFileName }}" width="249" height="308" /></div>
            </div>
            <div id="desc">
                <div id="shirtdesc">{{ShirtDesc}}</div>
                <div id="pantsdesc">{{PantsDesc}}</div>
            </div>
            <div id="shirttitle">{{ShirtTitle}}</div>
            <div id="pantstitle">{{PantsTitle}}</div>
        </div>
        
        <div id="pantsListView" class="thumbs sys-template">
            <div class="pant"><img sys:src="{{ 'images/thumb/' + FileNameFull }}" sys:class="{{ $index + ' p' }}" sys:alt="{{Title}}" sys:title="{{Title}}" width="65" height="66" /></div>
        </div>
    </div>
    
    <script type="text/javascript">          
        var shirts = <%= this._vm.Shirts %>;
        var pants = <%= this._vm.Pants %>;

        var itemView = 
            {
                PantIndex:0,
                ShirtIndex:0,
                ShirtFileName:"",
                ShirtDesc:"",
                ShirtTitle:"",
                PantsFileName:"",
                PantsDesc:"",
                PantsTitle:""
            };

        Sys.onReady(function()
        {
            bindShirts();
            bindPants();
            mapToItemView(0,0);
            bindFullView();
            initializeDD(); 
        });
        
        function bindFullView()
        {
            $create(Sys.UI.DataView, { data: itemView }, {}, {}, $get("fullView"));
        }
        
        function mapToItemView(shirtIndex, pantIndex)
        {
            itemView.PantsDesc = pants[pantIndex].Description;
            itemView.PantsFileName = pants[pantIndex].FileNameFull;
            itemView.PantsTitle = pants[pantIndex].Title;
            itemView.ShirtDesc = shirts[shirtIndex].Description;
            itemView.ShirtFileName = shirts[shirtIndex].FileNameFull;
            itemView.ShirtTitle = shirts[shirtIndex].Title;
        }
        
        function initializeDD()
        {
            var dd = new $IG.DragDropBehavior();

            $(".shirt img").each(function(index)
            {
                dd.addSourceElement(this);
            });

            $(".pant img").each(function(index)
            {
                dd.addSourceElement(this);
            });

            dd.addTargetElement($get("shirt0"), true);
            dd.addTargetElement($get("pant0"), true);
            dd.get_events().addDropHandler(onDropped);
        }
        
        function bindPants()
        {
            $create(Sys.UI.DataView, { data: pants }, {}, {}, $get("pantsListView"));
        }
        
        function bindShirts()
        {
            $create(Sys.UI.DataView, { data: shirts }, {}, {}, $get("shirtListView"));
        }

        function onDropped(source, eventArgs)
        {
            var src = eventArgs.get_manager().get_source().element;
            var args = src.className.split(' ');
            var index = args[0];
            var type = args[1];

            if (type == "s")
            {
                $("#shirt0").attr("src", "images/full/" + shirts[index].FileNameFull);
                $("#shirtdesc0").html(shirts[index].Description);
                $("#shirttitle0").html(shirts[index].Title);
            }
            else if (type == "p")
            {
                $("#pant0").attr("src", "images/full/" + pants[index].FileNameFull);
                $("#pantsdesc0").html(pants[index].Description);
                $("#pantstitle0").html(pants[index].Title);
            }
        }
    </script>
    
</body>
</html>
